import router from './router'
import type { RouteRecordRaw } from 'vue-router'
import { isRelogin } from '@/config/axios/service'
import { getAccessToken } from '@/utils/auth'
import { useTitle } from '@/hooks/web/useTitle'
import { useNProgress } from '@/hooks/web/useNProgress'
import { usePageLoading } from '@/hooks/web/usePageLoading'
import { useDictStoreWithOut } from '@/store/modules/dict'
import { useUserStoreWithOut } from '@/store/modules/user'
import { usePermissionStoreWithOut } from '@/store/modules/permission'
import { createVNode, render } from 'vue'
import ChangePasswordDialog from '@/views/system/ChangePasswordDialog.vue'
const { start, done } = useNProgress()

const { loadStart, loadDone } = usePageLoading()

// const parseURL = (
//   url: string | null | undefined
// ): { basePath: string; paramsObject: { [key: string]: string } } => {
//   // 如果输入为 null 或 undefined，返回空字符串和空对象
//   if (url == null) {
//     return { basePath: '', paramsObject: {} }
//   }
//
//   // 找到问号 (?) 的位置，它之前是基础路径，之后是查询参数
//   const questionMarkIndex = url.indexOf('?')
//   let basePath = url
//   const paramsObject: { [key: string]: string } = {}
//
//   // 如果找到了问号，说明有查询参数
//   if (questionMarkIndex !== -1) {
//     // 获取 basePath
//     basePath = url.substring(0, questionMarkIndex)
//
//     // 从 URL 中获取查询字符串部分
//     const queryString = url.substring(questionMarkIndex + 1)
//
//     // 使用 URLSearchParams 遍历参数
//     const searchParams = new URLSearchParams(queryString)
//     searchParams.forEach((value, key) => {
//       // 封装进 paramsObject 对象
//       paramsObject[key] = value
//     })
//   }
//
//   // 返回 basePath 和 paramsObject
//   return { basePath, paramsObject }
// }

// 路由不重定向白名单
const whiteList = [
  '/login',
  '/social-login',
  '/auth-redirect',
  '/bind',
  '/register',
  '/oauthLogin/gitee'
]

// 路由加载前
router.beforeEach(async (to, _, next) => {
  start()
  loadStart()

  if (getAccessToken()) {
    if (to.path === '/login') {
      next({ path: '/' })
    } else {
      // 获取所有字典
      const dictStore = useDictStoreWithOut()
      const userStore = useUserStoreWithOut()
      const permissionStore = usePermissionStoreWithOut()
      if (!dictStore.getIsSetDict) {
        await dictStore.setDictMap()
      }
      if (!userStore.getIsSetUser) {
        isRelogin.show = true
        await userStore.setUserInfoAction(to.query.pagepath)
        isRelogin.show = false
        // 后端过滤菜单
        await permissionStore.generateRoutes()
        permissionStore.getAddRouters.forEach((route) => {
          router.addRoute(route as unknown as RouteRecordRaw) // 动态添加可访问路由表
        })
        // const redirectPath = from.query.redirect || to.path
        // 修复跳转时不带参数的问题
        //  const redirect = decodeURIComponent(redirectPath as string)
        //  const { paramsObject: query } = parseURL(redirect)
        // const nextData = to.path === redirect ? { ...to, replace: true } : { path: redirect, query }
        // next(nextData)

        // 首次登录时跳转到SSO主页，刷新页面时保持当前页面
        next({ ...to, replace: true }) // 保持当前路由，只在首次登录时执行
      } else {
        next()
      }
    }
  } else {
    if (whiteList.indexOf(to.path) !== -1) {
      next()
    } else {
      next(`/login?redirect=${to.fullPath}`) // 否则全部重定向到登录页
    }
  }
})

router.afterEach((to, from) => {
  useTitle(to?.meta?.title as string)
  done() // 结束Progress
  loadDone()
  console.log(to.path, from.path)
  const userStore = useUserStoreWithOut()
  console.log(userStore.getUser)
  if (to.path !== '/login' && userStore.getUser.initPassword == 0) {
    const container = document.createElement('div')
    const vnode = createVNode(ChangePasswordDialog)
    render(vnode, container)
    document.body.appendChild(container)
    const dialogInstance = vnode.component?.exposed
    if (dialogInstance) {
      dialogInstance.open()
    }
  }
})
